<?php

namespace modules\sitemap;
use core\{application\Application, utility\Utility, database\Database, route\Route, translation\Translation as T};

class Sitemap {
	use Form;
	
	function admin() {
		Application::set_title('Создать файл Sitemap');

		if (isset($_POST['submit'])) {
			$this->make();
			Utility::set_message('success');
		}

		$result = $this->get_form();

		return $result;
	}

	function regenerate() {
		if (isset($_POST['submit'])) {
			$this->make();
		}
	}

	function make() {
		$languages = T::get_languages();		
		$url_base = Route::get_host();

		$route_aliases = Database::select('route_aliases')
			->data(['alias'])
			->fetch('assoc_all');
			
		$url = '';
		foreach ($languages as $language) {
			$language_data = [
				'language' => $language,
			];
			
			$url .= '<url>'.PHP_EOL.'<loc>'.Route::render_route($url_base, false, true, $language_data).'</loc>'.PHP_EOL.'</url>'.PHP_EOL;

			foreach ($route_aliases as $route_alias) {
				if ($route_alias['alias'] != '/') {
					$url .= '<url>'.PHP_EOL.'<loc>'.$url_base.Route::render_route($route_alias['alias'], true, false, $language_data).'</loc>'.PHP_EOL.'</url>'.PHP_EOL;
				}
			}
		}

		$sitemap = '<?xml version="1.0" encoding="UTF-8"?>'.PHP_EOL.'<urlset xmlns="https://www.sitemaps.org/schemas/sitemap/0.9">'.PHP_EOL.$url.'</urlset>'.PHP_EOL;

		file_put_contents(EQSASH_ROOT.'/sitemap.xml', $sitemap);
	}
}
